c
      subroutine symm_ident(ntrans,mtrx,tnp,id)
c
      implicit none
c
      integer ntrans
      integer mtrx(48,3,3)
      double precision tnp(48,3)
      character id(48)*10
c
      integer i,j, oper, ierr, ipt
      logical proper, nonsym(48)
      double precision det, trace, te, tt
      integer iv1(3)
      double precision a(3,3), z(3,3), wr(3), wi(3), fv1(3)
      double precision t(3), e(3), canon_t(3)
      double precision rdot
      character*2 axes(-2:2)
c
      data axes / 'C2', 'C3', 'C4', 'C6', 'E ' /

      do 100 oper = 1, ntrans
c
c       Copy the matrix to a double precision format for
c       processing with EISPACK. Also, copy the non-primitive
c       translation.
c      
        do 20 i = 1, 3
          do 10 j = 1 , 3
            a(i,j) = mtrx(oper,i,j)
            t(j) = tnp(48,j)
  10      continue
  20    continue
c
c       Compute determinant  and trace
c       
        det = a(1,1)*a(2,2)*a(3,3) + a(2,1)*a(3,2)*a(1,3) +
     &        a(1,2)*a(2,3)*a(3,1) - a(3,1)*a(2,2)*a(1,3) -
     &        a(2,1)*a(1,2)*a(3,3) - a(1,1)*a(3,2)*a(2,3)
c
        proper = (nint(det) .eq. 1)
c
        trace = a(1,1) + a(2,2) + a(3,3)
c
        if (proper) then
c
c           Proper operation
c

            id(oper) = axes(nint(trace - 1))
c
        else
c
c           R = IS , where S is proper
c
            call sscal(9,-1.d0,a,1)
            id(oper) = 'I' // axes(nint(-trace - 1))
c
        endif
  100 continue
c
      return
c
      end
