C*
C*
       SUBROUTINE WARN(I,XARG,IARG,ROUT)
C      HANDLES THE WARNINGS
C      AND KEEPS TRACK OF THEIR NUMBER
C
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       CHARACTER*6 ROUT
       DATA NWARN / 0 /
C
       IF(I .EQ. 0) THEN
         IF(NWARN .GE. 1) WRITE(9,1001) NWARN
       ELSE
         NWARN = NWARN + 1
         I10 = I/10
         IR = I - I10*10
         WRITE(9,1000) I,ROUT
C
         IF(I10 .EQ. 13) THEN
           IF(IR .EQ. 2) THEN
             WRITE(9,1132)
           ELSE IF(IR .EQ. 3) THEN
             WRITE(9,1133)
           ELSE IF(IR .EQ. 4) THEN
             WRITE(9,1134) XARG
           ELSE IF(IR .EQ. 5) THEN
             WRITE(9,1135) XARG
           ENDIF
         ELSE IF(I10 .EQ. 17) THEN
           IF(IR .EQ. 0) THEN
             WRITE(9,1170)
           ENDIF
         ELSE IF(I10 .EQ. 22) THEN
           IF(IR .EQ. 0) THEN
             WRITE(9,1220) IARG
           ELSE IF(IR .EQ. 1) THEN
             WRITE(9,1221) IARG
           ENDIF
         ELSE IF(I10 .EQ. 25) THEN
           IF(IR .EQ. 0) THEN
             WRITE(9,1250) XARG
           ELSE IF(IR .EQ. 2) THEN
             WRITE(9,1252) IARG,XARG
           ENDIF
         ELSE IF(I10 .EQ. 27) THEN
           IF(IR .EQ. 0) THEN
             WRITE(9,1270) IARG
           ELSE IF(IR .EQ. 1) THEN
             WRITE(9,1271) IARG,XARG
           ELSE IF(IR .EQ. 2) THEN
             WRITE(9,1272) XARG
           ENDIF
         ELSE IF(I10 .EQ. 28) THEN
           IF(IR .EQ. 0) THEN
             WRITE(9,1280)
           ENDIF
         ELSE IF(I10 .EQ. 29) THEN
           IF(IR .EQ. 0) THEN
             WRITE(9,1290) XARG
           ELSE IF(IR .EQ. 1) THEN
             WRITE(9,1291) XARG
           ENDIF
         ELSE IF(I10 .EQ. 30) THEN
           IF(IR .EQ. 0) THEN
             WRITE(9,1300) IARG
           ENDIF
         ELSE IF(I10 .EQ. 34) THEN
           IF(IR .EQ. 0) THEN
             WRITE(9,1340)
           ENDIF
         ELSE IF(I10 .EQ. 36) THEN
           IF(IR .EQ. 0) THEN
             WRITE(9,1360)
           ENDIF
         ELSE IF(I10 .EQ. 47) THEN
           IF(IR .EQ. 0) THEN
             WRITE(9,1470) XARG
           ENDIF
         ENDIF
C
       ENDIF
       RETURN
 1000  FORMAT('  *** WARNING *** ',I6,' IN ',A6)
 1001  FORMAT(/,2X,I3,' WARNINGS UP TO NOW')
 1132  FORMAT('  CHEMICAL SYMBOLS DO NOT MATCH')
 1133  FORMAT('  CORRELATION POTENTIAL DOES NOT MATCH')
 1134  FORMAT('  TAPE CONTAINS INFORMATION ABOUT',
     1        ' LOCAL POTENTIAL UP TO GMAX = ',E10.3)
 1135  FORMAT('  TAPE CONTAINS INFORMATION ABOUT',
     1        ' NON-LOCAL POTENTIAL UP TO GMAX = ',E10.3)
 1170  FORMAT('  ERROR READING SCREENING TAPE ',
     1        'DEFAULT SCREENING WAS USED')
 1220  FORMAT('  ERROR ',I5,' DIAGONALIZING HAMILTONIAN ')
 1221  FORMAT('  ERROR ',I5,' CALCULATING EIGENVECTORS')
 1250  FORMAT('  NON HERMITIAN DIIS MATRIX ',E10.3)
 1252  FORMAT('  INACCURATE DIIS EIGENVECTOR ',I4,E10.3)
 1270  FORMAT('  N(FFT) REDUCED IERR = ',I4)
 1271  FORMAT('  COMPLEX CHARGE DENSITY IN',
     1        ' REAL SPACE - IERR = ',I5,' MAXERR = ',E10.3)
 1272  FORMAT('  NEGATIVE CHARGE DENSITY IN',
     1        ' REAL SPACE, RHO-MIN = ',E10.3)
 1280  FORMAT('  UNKNOWN CORRELATION, EXC ASSUMED ZERO')
 1290  FORMAT('  WRONG TOTAL CHARGE DENSITY    DIFF = ',E10.3)
 1291  FORMAT('  COMPLEX TOTAL CHARGE DENSITY DENI(1) = ',E10.3)
 1300  FORMAT('  TRIVIAL UPDATE MATRIX, MXDUPD = ',I5)
 1340  FORMAT('  PROBLEMS IN BASIS SET REPLACEMENT')
 1360  FORMAT('  SOME SUBROUTINE CALLS IN MAIN PROGRAM',
     1        ' MAY BE INCOMPATIBLE WITH LIBRARY')
 1470  FORMAT('  FLAT BAND AT E = ',E10.3)
       END
C*
C*
       SUBROUTINE FATAL(I,XARG,IARG,ROUT)
C
C      HANDLES THE FATAL ERRORS
C      AND STOPS THE EXECUTION OF THE PROGRAM
C
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       CHARACTER*6 ROUT
C
       WRITE(9,1000) ROUT
       I10 = I/10
       IR = I - I10*10
       IF(I10 .EQ. 5) THEN
C        CRSTL
         IF(IR . EQ. 0) THEN
           WRITE(9,1050) XARG
         ELSE IF(IR .EQ. 1) THEN
           WRITE(9,1051) IARG
         ELSE IF(IR .EQ. 2) THEN
           WRITE(9,1052) IARG
         ENDIF
       ELSE IF(I10 .EQ. 9) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1090) XARG,IARG
         ELSE IF(IR .EQ. 1) THEN
           WRITE(9,1091) XARG,IARG
         ELSE IF(IR .EQ. 2) THEN
           WRITE(9,1092) XARG,IARG
         ELSE IF(IR .EQ. 3) THEN
           WRITE(9,1093) IARG
         ENDIF
       ELSE IF(I10 .EQ. 11) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1110) XARG
         ENDIF
       ELSE IF(I10 .EQ. 13) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1130) IARG
         ELSE IF(IR .EQ. 1) THEN
           WRITE(9,1131) IARG
         ENDIF
       ELSE IF(I10 .EQ. 19) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1190) IARG
         ELSE IF(IR .EQ. 1) THEN
           WRITE(9,1191) IARG
         ELSE IF(IR .EQ. 2) THEN
           WRITE(9,1192) IARG
         ENDIF
       ELSE IF(I10 .EQ. 21) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1210) IARG
         ENDIF
       ELSE IF(I10 .EQ. 22) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1220) IARG
         ENDIF
       ELSE IF(I10 .EQ. 23) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1230)
         ENDIF
       ELSE IF(I10 .EQ. 25) THEN
         IF(IR .EQ. 1) THEN
           WRITE(9,1251) IARG,XARG
         ENDIF
       ELSE IF(I10 .EQ. 27) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1270) IARG
         ENDIF
       ELSE IF(I10 .EQ. 33) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1330) IARG
         ENDIF
       ELSE IF(I10 .EQ. 34) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1340) IARG
         ELSE IF(IR .EQ. 1) THEN
           WRITE(9,1341) IARG
         ELSE IF(IR .EQ. 2) THEN
           WRITE(9,1342) IARG
         ELSE IF(IR .EQ. 3) THEN
           WRITE(9,1343) IARG
         ENDIF
       ELSE IF(I10 .EQ. 35) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1350) IARG
         ELSE IF(IR .EQ. 1) THEN
           WRITE(9,1351) IARG
         ENDIF
       ELSE IF(I10 .EQ. 36) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1360)
         ENDIF
       ELSE IF(I10 .EQ. 37) THEN
         IF(IR .EQ. 0) THEN
           WRITE(9,1370)
         ENDIF
       ENDIF
       STOP
 1000  FORMAT('  ***FATAL ERROR*** IN ',A6)
 1050  FORMAT('  CELL VOLUME = ',E12.5)
 1051  FORMAT('  TYPES OF ATOMS = ',I5)
 1052  FORMAT('  NUMBER OF ATOMS = ',I5)
 1090  FORMAT('  GMOD = ',E10.3,'  TRY  NO. OF G-VEC.= ',I6)
 1091  FORMAT('  GMAX = ',E10.3,'  NO. OF G-VEC.= ',I6)
 1092  FORMAT('  GMAX**2 = ',E10.3,
     1        '  FOR STAR NO.= ',I4)
 1093  FORMAT('  CHANGE MXDCUB TO AT LEAST  ',I5)
 1110  FORMAT('  PHASE AND STRUCTURE FACTORS',
     1        ' DO NOT AGREE, ERROR = ',E10.3)
 1130  FORMAT('  DIMENSIONS FOR LOCAL PSEUDOPO',
     1        'TENTIAL ARRAY TOO SMALL   MXD = ',I5)
 1131  FORMAT('  DIMENSIONS FOR NON-LOCAL PSEUDOPOTENTIAL',
     1        ' ARRAY TOO SMALL   MXD = ',I5)
 1190  FORMAT('  CHANGE MXDBND TO AT LEAST  ',I5)
 1191  FORMAT('  DIMENSIONS FOR UNSYMMETRIZED INTEGRATION',
     1        ' K-POINTS TOO SMALL   N=',I6)
 1192  FORMAT('  DIMENSIONS FOR NUMBER OF INTEGRATION K-POINTS',
     1        'TOO SMALL  N=',I5)
 1210  FORMAT('  CHANGE MXDDIM TO AT LEAST  ',I5)
 1220  FORMAT('  CHANGE MXDANL TO AT LEAST  ',I5)
 1230  FORMAT('  UNRECOGNIZED MATRIX STORAGE')
 1251  FORMAT('  WRONG DIIS EIGENVECTOR ',I4,E10.3)
 1270  FORMAT('  SIZE OF FFT ARRAY TOO SMALL  NFFT=',I7)
 1330  FORMAT('  UNABLE TO FIND EQUIVALENT ATOM FOR K= ',I5)
 1340  FORMAT('  CHANGE MXDSML TO AT LEAST  ',I5)
 1341  FORMAT('  INCREASE MXDSML MAYBE TO A VALUE OF  ',I5)
 1342  FORMAT('  INCREASE SMALL MATRIX SIZE, MTXDS, TO  ',I5)
 1343  FORMAT('  PROBLEMS WITH GRAM-SCHMIDT, NSIZE = ',I5)
 1350  FORMAT('  CHANGE MXDFFT TO AT LEAST  ',I5,
     1        '  OR USE ANOTHER WORK ARRAY')
 1351  FORMAT('  THE FFT MESH IS NOT SUFFICIENTLY LARGE',
     1        '  TRY MXDFFT TWICE OF ',I7,/,
     2        '  OR INCREASE KMSCR (KMAX)')
 1360  FORMAT('  INCOMPATIBLE VERSION OF DRIVER PROGRAM')
 1370  FORMAT('  INVALID CHOICE OF PSEUDOPOTENTIAL')
       END

c
c
c
      subroutine alccheck(wst,isize,istat)
      implicit none
      integer isize,istat
      character*(*) wst

      if(istat.ne.0) then
         write(9,'(a,a)') ' *** MEMORY ALLOCATION FAILED ON ARRAY ',wst
         write(9,'(a,i12)') '     ARRAY SIZE: ',isize
         call myflush(9)
         stop
      endif


      end
