c 
      program kbbinasc

c
c     converts binary pseudopotential files to ascii file suitable
c
c     1997 Bernd Pfrommer
c
c
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
c
      PARAMETER (NRMAX=2000,LMAX=5)
c
      dimension VQL(NRMAX),AR(NRMAX,LMAX),CDC(NRMAX),CDD(NRMAX)
      dimension INORM(LMAX)
c

      m4_ifdef([T3E],[
      integer IPXFARGC
      external IPXFARGC
      external PXFGETARG
      ],[
      integer iargc,nargs
      external iargc
      external getarg
      ])

      CHARACTER*2 xCORR,xAMEAT 
      CHARACTER*3 xREL
      CHARACTER*4 xICORE 
      CHARACTER*10 xRAY(6),xTITLE(7)
      character*255 ascfile, binfile
c
c
c     -------------------------------------------------------------
c
      m4_ifdef([T3E],[
      nargs = ipxfargc()
      ],[
      nargs = iargc()])
      if (nargs .ne. 2) then
         write(0,*) 'Usage: kbbinasc binfilename ascfilename'
         stop 
      endif
      m4_ifdef([T3E],[
      call pxfgetarg(1, binfile, ilen, ierror)
      call pxfgetarg(2, ascfile, ilen, ierror)
      ],[
      call getarg(1,binfile)
      call getarg(2,ascfile)
      ])
c
c     -------- read from the binary code -------------------------
c
      open (9,file=binfile,form='unformatted')
c
      read(9) xAMEAT,xCORR,xREL,xICORE,(xRAY(I),I=1,6),
     $     (xTITLE(I),I=1,7)

      WRITE(9,*) xAMEAT,xCORR,xREL,xICORE,(xRAY(I),I=1,6),
     $     (xTITLE(I),I=1,7)

      read(9) IZNUC,NQL,DELQL,VQL0

      write(9, 678) iznuc,nql, delql, vql0  
 678  format('iznuc=',i3,',  nql=',i5,', delql=',f9.5,', vql0=', f9.5)

      read(9) norb,(inorm(i),i=1,norb)

      write(9,*) 'inorms:'
      write(9,'(i3)') norb
      write(9,'(i3)') (inorm(i),i=1,norb)

      read(9) (vql(j),j=1,nql)
      do i=1,norb
        read(9) (ar(j,i),j=1,nql+1)
      end do

      write(9,*) 'first few components of local pot:'
      write(9,'(i6)') nql
      write(9,'(g12.4)') (vql(j), j=1,6)

      read(9) (cdc(j),j=2,nql+1)

      write(9,*) 'first few components of core charge density:'
      write(9,'(i6)') nql
      write(9,'(f12.6)') (cdc(j), j=2,7)

      read(9) (cdd(j),j=2,nql+1)

      write(9,*) 'first few components of valence charge density:'
      write(9,'(i6)') nql
      write(9,'(f12.6)') (cdd(j), j=2,7)

      close(unit=9)

c
c     --------- write to ascii file ----------------------------
c

      open(19,file=ascfile,
     $     status='unknown',form='formatted')
c
      write(19,1234) xAMEAT,xCORR,xREL,xICORE
 1234 format(1x,a2,1x,a2,1x,a3,1x,a4)
      write(19,1235) (xRAY(I),I=1,6)
 1235 format(6a10)
      write(19,1236) (xTITLE(I),I=1,7)
 1236 format(7a10)
      write(19,1237) IZNUC,NQL,DELQL,VQL0
 1237 format(2(1x,i5),2(1x,f20.12))
      write(19,2237)  NORB,(INORM(I),I=1,NORB)
 2237 format(10i5)
      write(19,1238) (VQL(J),J=1,NQL)
 1238 format(2(1x,f25.15))
      do i=1,NORB
         write(19,1238) (AR(j,i),j=1,NQL+1)
      end do
      write(19,1238) (CDC(j),j=2,NQL+1)
      write(19,1238) (CDD(j),j=2,NQL+1)
c
      end
