c
      subroutine chkpt_chi(irk, rhom_r, r_size,myproc,
     $     chivv, chihh, ioutput, ireadwrite)


      implicit none             ! implicit? Just say no!
c
c     1997 Bernd Pfrommer while at UCB
c

c     INPUT:
c     -----
      integer 
     $     ireadwrite,          ! if 1 then write, else read
     $     irk,                 ! at which kpoint the last chkpointing was
     $     myproc,              ! which proc I am
     $     r_size,              ! size of rhom array
     $     ioutput              ! flag for printing output


      complex(kind=8) 
     $     chivv(3,3),          ! the data to be saved
     $     chihh(3,3),
     $     rhom_r(r_size)       
      

c
c     DESCRIPTION:
c     -----------
c
c     For each processor, a checkpoint file is written/read which
c     saves/retreives the necessary state for the chi calculation

c     ---------------- local variables ----------------------------------

      double precision t0, gimmetime

      external gimmetime

      character*(255) filename    ! name of file to be written

      t0=gimmetime()

      write(filename,'(''CHKPTCHI.'',i3.3)') myproc

      open(75,file=filename,form='unformatted')

      if(ireadwrite.eq.1) then
         write(75) irk,r_size
         write(75) chivv, chihh
         write(75) rhom_r
         close(75)
         if(iand(ioutput,8).eq.8) 
     $        write(9,100) gimmetime()-t0
      else
         read(75) irk,r_size
         read(75) chivv, chihh
         read(75) rhom_r
         close(75)
         if(iand(ioutput,8).eq.8) 
     $        write(9,110) gimmetime()-t0
      endif

      call myflush(9)

      return

 100  format(' TIME TO WRITE CHKPTCHI:',f12.3)
 110  format(' TIME TO READ CHKPTCHI:',f12.3)

      end 



