c
      double precision function fft_opcount(n)

      implicit none            
c
c     INPUT:
c     -----

      integer n                 ! length of the FFT
c
c     RETURNS:
c     ------
c     operation count for FFT

      double precision opcnt
      integer i


      opcnt = 0.0
      i = n
      do while ( mod(i,2) .eq. 0 )
         i = i/2
         opcnt = opcnt + 5.0 * n
      end do

      do while ( mod(i,3) .eq. 0 )
         i = i/3
         opcnt = opcnt + 9.3333333 * n
      end do

      do while ( mod(i,5) .eq. 0 )
         i = i/5
         opcnt = opcnt + 14.4 * n
      end do

      if(i.ne.1) then
c
c        dunno what to do. Just take something reasonable....
c
         opcnt = 5*dble(n)*log(dble(n))/log(2.d0)
      endif


      fft_opcount = opcnt

      return
      end

