c
      double precision function switch(x,c)
c
c  Converts input values according to the control parameter c
c
c  Last modification: MOD_DATE
c
C     .. Scalar Arguments ..
      double precision x
      character c*1
C     ..
C     .. Local Scalars ..
      double precision sign
C     ..
C     .. Intrinsic Functions ..
      intrinsic abs, sqrt
C     ..
C     .. External Functions ..
      logical leqi
      external leqi 
C     ..
      sign = 1.d0
      if (x .lt. 0.d0) sign = -sign
      x = abs(x)
      if (leqi(c,'s')) x = sqrt(x)
      if (leqi(c,'c')) x = x**(1.d0/3.d0)
      if (leqi(c,'t')) x = x/3.d0
      if (leqi(c,'d')) x = x/2.d0
      if (leqi(c,'r')) x = x/sqrt(2.d0)
      if (leqi(c,'h')) x = x/sqrt(3.d0)
      if (leqi(c,'i')) x = 1.d0/x
      if (leqi(c,'a')) x = sqrt(x/3.d0)
      if (leqi(c,'b')) x = x/(6.d0*7.5d0)
c
      switch = sign*x
c
      return
c
      end
